function [U,T] = Generate_Complex_Screen_Field_Instance(SD,PSD,delta,numInstances)
%
% OUTPUTS
% U = complex screen field instance
% T = complex screen
% INPUTS
% SD = spectral density of desired Schell-model source
% PSD = spatial power spectrum of desired Schell-model source
% delta = grid spacing
% numInstances = number of field instances
%

[Ny,Nx] = size(PSD);
T = Generate_Complex_Amplitude_Screens(PSD,Nx,Ny,delta,numInstances);
U = sqrt(repmat(SD,[1 1 numInstances])).*T;
end

function T = Generate_Complex_Amplitude_Screens(PSD,Nx,Ny,delta,numScreens)
%
%
%
%
%

delfx = 1/(Nx*delta);
delfy = 1/(Ny*delta);
r_squig = (randn(Ny,Nx,numScreens) + 1j*randn(Ny,Nx,numScreens)) ...
    .*repmat(sqrt(PSD/2),[1 1 numScreens])*sqrt(delfx*delfy);
T = Nx*Ny*ifftshift(ifft(ifftshift(ifftshift(ifft(ifftshift(r_squig,1), ...
    [],1),1),2),[],2),2);
end